export declare type BoardSettings = {
    type?: "movable" | "scrollable";
};
export declare type ZoomSettings = {
    center?: boolean;
    inverse?: boolean;
    onScroll?: boolean;
    min?: number;
    max?: number;
};
export declare type ZoomToFitSettings = {
    centerNodes?: boolean;
    padding?: number;
    onStart?: boolean;
};
export declare type AutoDistributeSettings = {
    padding?: number;
    offset?: {
        top?: number;
        left?: number;
    };
    renderer?: Function;
    repaint?: boolean;
};
export declare type EngineSettings = {
    board?: BoardSettings;
    zoom?: ZoomSettings;
    zoomToFit?: ZoomToFitSettings;
    autoDistribute?: AutoDistributeSettings;
};
export default class Settings {
    settings: EngineSettings;
    constructor(settings: EngineSettings);
    get(name: string, overrides?: Object): Object;
}
